package
{

	import flash.net.Responder;
	import flash.net.NetStream;
	import flash.net.NetConnection;
	import flash.net.ObjectEncoding;

	import flash.media.Video;
	import flash.media.Camera;
	import flash.media.Microphone;
	
	import flash.events.TimerEvent;
	import flash.events.NetStatusEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	import flash.utils.Timer;
	import flash.display.Sprite;
	
	
	public class MilGraDemoRemote extends Sprite
	{
		
		public var state:String = "normalpublish";
		
		public var cam : Camera;
		public var mic : Microphone;
		public var video : Video;
		public var playVideo : Video;
		
		public var timer : Timer;
		public var stream : NetStream;
		public var playStream : NetStream;
		
		public var textfield : TextField;
		public var textformat : TextFormat;
		public var connection : NetConnection;
		
		
		public function MilGraDemoRemote ( )
		{
			
			cam = Camera.getCamera( );
			mic = Microphone.getMicrophone( );
			
			textformat = new TextFormat( );
			textformat.font = "Arial";
			textformat.size = 12;
			textformat.color = 0x000066;
						
			textfield = new TextField( );
			textfield.y = 120;
			textfield.width = 440;
			textfield.height = 200;
			textfield.multiline = true;
			textfield.wordWrap = true;
			textfield.defaultTextFormat = textformat;
			addChild( textfield );
			
			video = new Video( 160 , 120 );
			video.attachCamera( cam );
			addChild( video );
			
			playVideo = new Video( 160 , 120 );
			playVideo.x = 160;
			addChild( playVideo );
			
			connection = new NetConnection( );
			connection.client = this;
			connection.objectEncoding = ObjectEncoding.AMF0;
			connection.addEventListener( NetStatusEvent.NET_STATUS , onStatus );
			connection.connect( "rtmp://localhost/milgrademoremote" );
									
			timer = new Timer( 5000 );
			timer.addEventListener( TimerEvent.TIMER , stepDemo );
			
			state = "publishstream";
			timer.start( );
			
		}
		
		
		public function onStatus ( eventX:NetStatusEvent ):void
		{
			
			textfield.appendText( "Connection status: " + eventX.info.code + " \n" );
			
			if ( eventX.info.code == "NetConnection.Connect.Success" ) stepDemo( new TimerEvent( "" ) );
			if ( eventX.info.code == "NetConnection.Connect.Rejected" ) textfield.appendText( eventX.info.application );
			
		}
		
		
		public function stepDemo ( eventX:TimerEvent ):void
		{
			switch ( state )
			{
				
				case "publishstream" : publishNormal( ); break;
				case "connectback" : connectBack( ); break;
				case "callremote" : callRemote( ); break;
				case "playremote" : playRemote( ); break;
				case "publishremote" : publishRemote( ); break;
				
			}
			
		}
		
		
		public function publishNormal ( ):void
		{
		
			textfield.appendText( "Publishing normalstream\n" );
			stream = new NetStream( connection );
			stream.attachAudio( mic );
			stream.attachCamera( cam );
			stream.publish( "normalstream" , "live" );	
			
			state = "connectback";
			
		}
		
		
		public function connectBack ( ):void
		{
			
			textfield.appendText( "Telling the demo application to open a remote connection to itself\n" );
			connection.call( "connectBack" , null );
			
			state = "callremote";
			
		}
		
		
		public function callRemote ( ):void
		{
			
			textfield.appendText( "Telling the demo application to invoke a remote method ( on itself :) )\n" );
			connection.call( "callRemote" , null );	
			
			state = "publishremote";
			
		}
		
		
		public function publishRemote ( ):void
		{
			
			textfield.appendText( "Telling the demo application to publish the previous stream on the new connection with name remotestream\n" );
			connection.call( "publishStream" , null );
			
			state = "playremote";
			
		}
		
		
		public function playRemote ( ):void
		{
				
			textfield.appendText( "Now the stream is proxied throguh a remote connection ( to oruself ), trying to play the new stream" );
			
			playStream = new NetStream( connection );
			playStream.play( "remotestream" );
			
			playVideo.attachNetStream( playStream );
			timer.stop( );
			
		}
					
	}
	
}