package
{
	
	import flash.net.Responder;
	import flash.net.NetStream;
	import flash.net.NetConnection;
	import flash.net.ObjectEncoding;
		
	import flash.media.Video;
	import flash.media.Camera;
	import flash.media.Microphone;
	
	import flash.text.TextField;
	import flash.utils.Timer;
	import flash.display.Sprite;
	
	import flash.events.TimerEvent;
	import flash.events.NetStatusEvent;
	import flash.text.TextFormat;
	
	
	public class MilGraDemoStream extends Sprite
	{
		
		public var timer:Timer;
		public var state:String;
		
		public var cam:Camera;
		public var mic:Microphone;
		
		public var video:Video;
		public var playVideo:Video;
		
		public var stream:NetStream;
		public var validStream:NetStream;
		public var invalidStream:NetStream;
		
		public var validPlay:NetStream;
		public var invalidPlay:NetStream;
		
		public var textfield:TextField;
		public var textformat:TextFormat;
		public var connection:NetConnection;
		
		
		public function MilGraDemoStream ( )
		{
			
			cam = Camera.getCamera( );
			mic = Microphone.getMicrophone( );
			
			textformat = new TextFormat( );
			textformat.font = "Arial";
			textformat.size = 12;
			textformat.color = 0x000066;
						
			textfield = new TextField( );
			textfield.y = 120;
			textfield.width = 440;
			textfield.height = 200;
			textfield.wordWrap = true;
			textfield.multiline = true;
			textfield.defaultTextFormat = textformat;
			addChild( textfield );
			
			video = new Video( 160 , 120 );
			video.attachCamera( cam );
			addChild( video );
			
			playVideo = new Video( 160 , 120 );
			playVideo.x = 160;
			playVideo.y = 0;
			addChild( playVideo );
			
			connection = new NetConnection( );
			connection.client = this;
			connection.objectEncoding = ObjectEncoding.AMF0;
			connection.addEventListener( NetStatusEvent.NET_STATUS , onStatus );
			connection.connect( "rtmp://localhost/milgrademostream" );			
						
			timer = new Timer( 5000 );
			timer.addEventListener( TimerEvent.TIMER , stepDemo );
			
			state = "publishnormal";
			timer.start( );
			
		}
		
		
		public function onStatus ( eventX:NetStatusEvent ):void
		{
			
			textfield.appendText( "Connection status: " + eventX.info.code + "\n" );
			if ( eventX.info.code == "NetConnection.Connect.Success" ) stepDemo( new TimerEvent( "" ) );
			
		}
		
		
		public function stepDemo ( event:TimerEvent ):void
		{
			trace( state );
			
			switch ( state )
			{
				
				case "publishnormal" : publishNormalStream( ); break;
				case "publishinvalid" : publishInvalidStream( ); break;
				case "publishvalid" : publishValidStream( ); break;
				case "recordvalid" : recordValidStream( ); break;
				case "removenormal" : removeNormalStream( ); break;
				case "playinvalid" : playInvalidStream( ); break;
				case "playvalid" : validPlayStream( ); break;
				
			}
			
		}
		
		
		public function publishNormalStream ( ):void
		{

			textfield.appendText( "Publishing \"normalstream\", server accepts it by default, because stream event listener is undefined\n" );
			
			stream = new NetStream( connection );
			stream.attachAudio( mic );
			stream.attachCamera( cam );
			stream.publish( "normalstream" , "record" );
			
			state = "publishinvalid";
			
		}
		
		
		public function publishInvalidStream ( ):void
		{
			
			textfield.appendText( "Adding stream event listener on server side\n" );
			connection.call( "addStreamEventListener" , null );
			
			textfield.appendText( "trying to publish a stream with an invalid name\n" );			
			invalidStream = new NetStream( connection );
			invalidStream.attachAudio( mic );
			invalidStream.attachCamera( cam );
			invalidStream.publish( "invalidstream" , "live" );
			
			state = "publishvalid";
			
		}
		
		
		public function publishValidStream ( ):void
		{
						
			textfield.appendText( "publishing stream with a valid name, server accepts it with a modified name\n" );
			validStream = new NetStream( connection );
			validStream.addEventListener( NetStatusEvent.NET_STATUS , onStatus );
			validStream.attachAudio( mic );
			validStream.attachCamera( cam );
			validStream.publish( "validstream" , "live" );
			
			state = "recordvalid";
			
		}
		
		
		public function recordValidStream ( ):void
		{
			
			textfield.appendText( "tell demo application to record previous stream\n" );			
			connection.call( "recordValidStream" , null );
			
			state = "removenormal";
			
		}
		
		
		public function removeNormalStream ( ):void
		{
			
			textfield.appendText( "tell demo application to remove first stream, which is recorded\n" );
			connection.call( "removeNormalStream" , null );
			
			state = "playinvalid";
			
		}
		
		
		public function playInvalidStream ( ):void
		{
			
			textfield.appendText( "playing an invalid stream, demo application will refuse\n" );
			invalidPlay = new NetStream( connection );
			invalidPlay.play( "invalidstream" );
			
			state = "playvalid";
			
		}
		
		
		public function validPlayStream ( ):void
		{
			
			textfield.appendText( "playing the valid stream, demo application allows it\n" );			
			textfield.appendText( "you can check recorded streams under Milenia Grafter Server/streams\n" );
						
			validPlay = new NetStream( connection );
			validPlay.addEventListener( NetStatusEvent.NET_STATUS , onStatus );
			validPlay.play( "validstream" );
			
			playVideo.attachNetStream( validPlay );
			
			timer.stop( );	
			
		}			
			
	}
	
}